/* A Bison parser, made from bapascal.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	UNSIGNED_INT	257
# define	STRING	258
# define	RAWSTRING	259
# define	STRINGCONCAT	260
# define	STRINGCOMPARE	261
# define	STRINGCOPY	262
# define	STRINGLENGTH	263
# define	SSCANF	264
# define	SPRINTF	265
# define	IDENTIFIER	266
# define	CHAR	267
# define	INT	268
# define	NE	269
# define	LE	270
# define	GE	271
# define	BECOMES	272
# define	DIV	273
# define	MOD	274
# define	OR	275
# define	AND	276
# define	NOT	277
# define	DOTDOT	278
# define	IF	279
# define	THEN	280
# define	ELSE	281
# define	CASE	282
# define	OF	283
# define	REPEAT	284
# define	UNTIL	285
# define	WHILE	286
# define	DO	287
# define	FOR	288
# define	TO	289
# define	CBEGIN	290
# define	SBEGIN	291
# define	END	292
# define	CEND	293
# define	CONST	294
# define	VAR	295
# define	TYPE	296
# define	ARRAY	297
# define	FUNCTION	298
# define	MONITOR	299
# define	PROCEDURE	300
# define	PROGRAM	301
# define	INCLUDE	302
# define	ATOMIC	303
# define	FNSTRING	304
# define	SEND	305
# define	RECEIVE	306
# define	BROADCAST	307
# define	EXTERNAL	308
# define	LOWER_THAN_ELSE	309

#line 1 "bapascal.y"

       /* yacc grammar for BenAri Concurrent Pascal */
       /* based on the Pascal grammar from the      */
       /* primost.cs.wisc.edu compiler archive      */
#include <stdio.h>
#include <string.h>
#include <time.h>

extern   int   yylineno;
extern   int   yydebug;
extern   char  yytext[];
extern   char  numbertext[];
extern   int   numberbase;
extern   char  laststring[];
extern   char  lastident[];
extern   char  lasttoken[];

extern   void  global_init(int argc, char** argv);


#include "../include/globdata.h"
#include "../include/globtabs.h"
#include "../include/compdata.h"
#include "../include/genutil.h"
#include "../include/computil.h"
#include "../include/incfiles.h"
#include "../include/pcode.h"

extern   int fprintf(FILE*,const char*,...);
extern   int printf(const char*,...);
extern   int free(void*);
extern   void yyerror(char*);
extern   int yylex(void); 
extern   int atoi(char*);

void process_var_inits(int level);
void add_var_init(int* curr_var, int tix, int level, int value);

#define YYDEBUG 1

char  comp_tail[] = {"BenAri Pascal PCODE Compiler, "};
extern char  comp_date[];  /* set in date.c on compilation day */

char  source_suffix[] = {".pm"};
char  list_suffix[] = {".lst"};

extern FILE  *yyin;  /* source file */
extern FILE  *yyout; /* listing file */

BUFFER   pbuf;   /* string buffer for parsing */
/* constants for passing synthesized information back up the parse tree */
int dx;           /* to calc size of the stackframe of a proc or function */
int level=0;      /* current static level */
int in_mon_decl;  /* 1 if in a monitor decl, 0 otherwise */
int in_mon_init;  /* 1 if in monitor init code, 0 otherwise */

/* for passing type of constant back to constant productions */
TYPES consttype;
/* for passing back information to productions using 'type' prod */

extern FNAME_STRING test;
#define NO_EXPR -1
   /* to pass up the parse tree when no entry in the expr array */
   /* has been generated                                        */

#define MAXARNEST 50    /* max nesting in function calls */
struct {
   int   aref;    /* atab index */
   TYPES eltyp;   /* element type for this atab index */
} arstack[MAXARNEST];
int   topars = -1;   /* index of top item on arstack */
int   last_aref;  /* for calculating array references */
TYPES last_eltyp;

#define MAXPFNEST 50    /* max nesting in function calls */
struct {
   int   pct;     /* parm count for this call */
   int   tix;     /* tab index for this proc or function */
} pfstack[MAXPFNEST];
int   toppfs = -1;   /* index of top item on pfstack */
int   last_pfv;   /* tab index of last proc func or variable ref */
int   last_pf;    /* tab index of last proc or func ref */
int   parmct;     /* count of parms in a proc or func call */
int   prt;        /* tab index of current proc */

#define MAXVARINIT   100   /* max # of vbls to be initialized */
   /* at present, only monitors need this data structure,     */
   /* because the grammar allows variable declaration and     */
   /* function declaration to be intermixed in the outer      */
   /* level of the monitor.  The actual intialization has to  */
   /* be postponed until the monitor init code is generated.  */
   /* The var_init list is never shortened.  The lev field of */
   /* a variable is set to -1 after it's initialized.         */
struct {
   int   value;         /* value of the variable */
   int   lev;           /* level of the variable  */
   int   tix;           /* tab index of the variable */
}var_init[MAXVARINIT];  
int   curr_var = -1;

int   in_cobegin = 0;  /* 1 when in COBEGIN-COEND block */
int   atomic;     /* pass ATOMIC proc or func up the parse tree */

int   in_include = 0;  /* to signal yylex to change its tactics */

extern int last_predeclared;  /* tab index of last predeclared id */

int making_objfile = 0; /* 1 if -c option --> make an object file, else 0 */

int external = 0;    /* 1 if an external var decl is underway, else 0 */

int  sscanf_cnt = 0;    /* number of sscanf addresses pushed */

int  sprintf_cnt = 0;   /* number of sprintf addresses pushed */

int outer_call_lc;      /* lc of the SHORTCALL instr to the outerblock */
int ob_tix;             /* tab index of the outer block */
int main_declared = 0;  /* 1 if the PROGRAM keyword has been seen */

int in_proc_decl;       /* 1 if in a procedure or function decl, 0 otherwise */


#define emit_push_addr(x)  (\
emit2(((x).normal ? LOAD_ADDR : LOAD_VALUE), (x).lev, (x).adr))

#ifndef YYSTYPE
# define YYSTYPE int
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 1
#endif



#define	YYFINAL		368
#define	YYFLAG		-32768
#define	YYNTBASE	71

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 309 ? yytranslate[x] : 192)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,    58,     2,     2,     2,     2,
      66,    67,    70,    60,    64,    61,    57,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    65,    56,
      68,    59,    69,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    62,     2,    63,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     3,     7,    10,    11,    13,    16,    18,    20,
      22,    24,    26,    28,    30,    32,    34,    36,    41,    44,
      46,    48,    50,    56,    58,    61,    65,    69,    72,    73,
      75,    78,    80,    82,    84,    86,    88,    90,    92,    95,
      98,   101,   105,   109,   111,   115,   117,   120,   123,   125,
     128,   131,   133,   135,   139,   143,   145,   149,   151,   153,
     155,   157,   165,   169,   171,   174,   177,   178,   183,   187,
     191,   193,   198,   200,   204,   206,   207,   210,   212,   216,
     220,   223,   227,   228,   230,   233,   236,   239,   243,   248,
     251,   252,   256,   260,   262,   264,   266,   268,   272,   277,
     281,   286,   290,   292,   294,   296,   300,   302,   304,   308,
     310,   313,   316,   317,   319,   321,   323,   325,   328,   333,
     338,   343,   346,   350,   353,   356,   358,   360,   362,   364,
     367,   372,   376,   378,   381,   385,   388,   392,   393,   397,
     401,   403,   405,   407,   409,   410,   412,   414,   416,   418,
     420,   426,   429,   432,   435,   439,   443,   447,   449,   453,
     458,   464,   466,   470,   472,   476,   478,   480,   482,   484,
     486,   488,   490,   493,   496,   500,   502,   504,   506,   508,
     510,   514,   516,   518,   520,   522,   524,   526,   528,   530,
     534,   537,   541,   543,   545,   547,   548,   550,   552,   554,
     556,   560,   563,   567,   571,   575,   581,   586,   592,   594,
     598,   603,   605,   609,   611,   616,   618
};
static const short yyrhs[] =
{
      72,    73,     0,    72,    73,    82,     0,    72,    82,     0,
       0,    74,     0,    73,    74,     0,    88,     0,   112,     0,
     129,     0,    95,     0,    90,     0,   106,     0,    75,     0,
      76,     0,    77,     0,    80,     0,    78,    41,   107,    56,
       0,    78,    79,     0,    54,     0,   115,     0,   120,     0,
      78,   130,    81,    38,    56,     0,    79,     0,    81,    79,
       0,    83,   135,    57,     0,    84,    56,    85,     0,    47,
     191,     0,     0,    86,     0,    86,    87,     0,    87,     0,
      88,     0,    90,     0,    95,     0,   106,     0,   112,     0,
     129,     0,    89,     5,     0,    58,    48,     0,    89,    50,
       0,    40,    91,    56,     0,    91,    56,    92,     0,    92,
       0,   191,    59,    93,     0,    94,     0,    60,    94,     0,
      61,    94,     0,   190,     0,    60,   190,     0,    61,   190,
       0,    13,     0,     3,     0,    42,    96,    56,     0,    96,
      56,    97,     0,    97,     0,   191,    59,    98,     0,    99,
       0,   100,     0,   105,     0,   190,     0,    43,    62,   101,
      63,   104,    29,    98,     0,   101,    64,   102,     0,   102,
       0,   103,    93,     0,    93,    24,     0,     0,     4,    62,
      93,    63,     0,    41,   107,    56,     0,   107,    56,   108,
       0,   108,     0,   109,    65,    98,   111,     0,   110,     0,
     110,    64,   191,     0,   191,     0,     0,    18,    93,     0,
     113,     0,   114,   135,    56,     0,   119,   135,    56,     0,
     115,    85,     0,   116,   117,    56,     0,     0,    49,     0,
     118,   123,     0,    46,    12,     0,   120,    85,     0,   116,
     121,    56,     0,   122,   123,    65,   190,     0,    44,    12,
       0,     0,    66,   124,    67,     0,   124,    56,   125,     0,
     125,     0,   126,     0,   127,     0,   128,     0,   109,    65,
     190,     0,    41,   109,    65,   190,     0,   109,    65,     4,
       0,   130,   131,   132,    56,     0,    45,   191,    56,     0,
      85,     0,    38,     0,   133,     0,   134,   136,    38,     0,
      37,     0,   133,     0,   136,    56,   137,     0,   137,     0,
       1,    56,     0,     1,    38,     0,     0,   133,     0,   148,
       0,   150,     0,   156,     0,   138,   139,     0,   138,   139,
     140,   137,     0,   141,   142,    33,   137,     0,   143,   136,
      31,   167,     0,   145,   137,     0,   147,   136,    39,     0,
      25,   167,     0,    26,   137,     0,    27,     0,    32,     0,
     167,     0,    30,     0,    34,   190,     0,   146,    35,   167,
      33,     0,   144,    18,   167,     0,    36,     0,   149,   167,
       0,   186,    18,   167,     0,   190,    18,     0,   154,   155,
     151,     0,     0,    66,   152,    67,     0,   152,    64,   153,
       0,   153,     0,   167,     0,     5,     0,   190,     0,     0,
     157,     0,   159,     0,   160,     0,   163,     0,   164,     0,
      51,   158,    64,   167,    67,     0,    66,   162,     0,    66,
     167,     0,    53,   181,     0,     6,   158,   161,     0,    64,
     167,    67,     0,    64,   162,    67,     0,     5,     0,     8,
     158,   161,     0,   165,    64,   166,    67,     0,    11,    66,
     167,    64,   162,     0,   167,     0,   166,    64,   167,     0,
     169,     0,   170,   168,   169,     0,    59,     0,    68,     0,
      69,     0,    16,     0,    17,     0,    15,     0,   172,     0,
      60,   172,     0,    61,   172,     0,   170,   171,   172,     0,
     169,     0,    60,     0,    61,     0,    21,     0,   175,     0,
     173,   174,   175,     0,   172,     0,    70,     0,    19,     0,
      20,     0,    22,     0,   176,     0,    94,     0,    13,     0,
      66,   167,    67,     0,    23,   175,     0,   154,   177,   151,
       0,   178,     0,   186,     0,   189,     0,     0,   179,     0,
     180,     0,   182,     0,   183,     0,     7,   158,   161,     0,
       9,   181,     0,    66,   167,    67,     0,    66,     5,    67,
       0,    52,   158,    67,     0,    52,   158,    64,   167,    67,
       0,   184,    64,   185,    67,     0,    10,    66,   167,    64,
     162,     0,   167,     0,   185,    64,   167,     0,   187,    62,
     188,    63,     0,   190,     0,   188,    64,   167,     0,   167,
       0,    14,    66,   167,    67,     0,    12,     0,    12,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   145,   158,   165,   174,   188,   189,   192,   193,   194,
     195,   196,   197,   198,   201,   202,   203,   206,   210,   216,
     220,   222,   226,   235,   236,   239,   260,   269,   282,   283,
     286,   287,   290,   291,   292,   293,   294,   295,   298,   310,
     316,   328,   331,   332,   335,   343,   345,   347,   349,   351,
     359,   367,   371,   375,   378,   379,   382,   401,   402,   403,
     406,   431,   475,   477,   480,   497,   507,   511,   526,   529,
     530,   533,   598,   601,   602,   605,   607,   615,   618,   625,
     634,   642,   649,   651,   656,   659,   676,   684,   691,   703,
     720,   722,   726,   727,   730,   731,   732,   735,   759,   783,
     803,   814,   833,   840,   846,   849,   852,   862,   865,   866,
     867,   869,   873,   874,   875,   876,   877,   878,   880,   882,
     884,   886,   889,   893,   897,   901,   905,   909,   913,   917,
     931,   941,   950,   962,   978,   996,  1021,  1057,  1058,  1061,
    1062,  1065,  1074,  1089,  1093,  1120,  1121,  1122,  1123,  1124,
    1127,  1154,  1156,  1170,  1184,  1197,  1209,  1213,  1226,  1239,
    1247,  1258,  1270,  1284,  1285,  1302,  1303,  1304,  1305,  1306,
    1307,  1310,  1311,  1320,  1331,  1354,  1358,  1359,  1360,  1363,
    1364,  1391,  1395,  1396,  1397,  1398,  1401,  1402,  1410,  1418,
    1419,  1432,  1482,  1483,  1484,  1487,  1508,  1509,  1510,  1511,
    1514,  1533,  1552,  1563,  1575,  1589,  1614,  1629,  1640,  1649,
    1660,  1673,  1704,  1714,  1726,  1733,  1737
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "UNSIGNED_INT", "STRING", "RAWSTRING", 
  "STRINGCONCAT", "STRINGCOMPARE", "STRINGCOPY", "STRINGLENGTH", "SSCANF", 
  "SPRINTF", "IDENTIFIER", "CHAR", "INT", "NE", "LE", "GE", "BECOMES", 
  "DIV", "MOD", "OR", "AND", "NOT", "DOTDOT", "IF", "THEN", "ELSE", 
  "CASE", "OF", "REPEAT", "UNTIL", "WHILE", "DO", "FOR", "TO", "CBEGIN", 
  "SBEGIN", "END", "CEND", "CONST", "VAR", "TYPE", "ARRAY", "FUNCTION", 
  "MONITOR", "PROCEDURE", "PROGRAM", "INCLUDE", "ATOMIC", "FNSTRING", 
  "SEND", "RECEIVE", "BROADCAST", "EXTERNAL", "LOWER_THAN_ELSE", "';'", 
  "'.'", "'#'", "'='", "'+'", "'-'", "'['", "']'", "','", "':'", "'('", 
  "')'", "'<'", "'>'", "'*'", "program", "init_outerscope", "outer_decls", 
  "outer_decl", "extern_decl", "extern_var_decl", "extern_proc_decl", 
  "the_external", "proc_or_func_proto", "extern_mon_decl", "proto_list", 
  "pgm_decl", "pgm_hdg_decls", "pgm_heading", "opt_declarations", 
  "declarations", "declaration", "include_dcl_part", "start_include", 
  "const_dcl_part", "const_defs", "const_def", "constant", "unsigned_num", 
  "type_dcl_part", "type_defs", "type_def", "type", "simple_type", 
  "struct_type", "index_type", "dimension", "low", "last_atab", 
  "string_type", "var_dcl_part", "variable_dcls", "variable_dcl", 
  "newident_list", "new_id_list", "opt_initializer", "proc_dcl_part", 
  "proc_or_func", "proc_hdg_decl", "proc_proto", "opt_atomic", 
  "proc_heading", "proc_id", "func_hdg_decl", "func_proto", 
  "func_heading", "func_id", "formal_params", "formal_p_sects", 
  "formal_p_sect", "param_group", "var_param_group", "string_param_group", 
  "mon_dcl_part", "mon_heading", "mon_decl", "opt_stmt_part", 
  "compound_stmt", "the_begin", "statement_part", "statements", 
  "statement", "if_expr", "then_stmt", "the_else", "the_while", 
  "while_expr", "the_repeat", "for_id", "for_header", 
  "for_id_becomes_expr", "cbegin", "assignment", "id_becomes", 
  "procedure_call", "actual_params", "actuals_list", "actual_param", 
  "pfv_id", "check_proc", "special_proc_call", "send_call", 
  "left_exprparm", "broadcast_call", "stringconcat_call", 
  "right_stringparm", "rawstring_parm", "stringcopy_call", "sprintf_call", 
  "sprintf_buf_fmt", "sprintf_parmlist", "expr", "relational_op", 
  "simple_expr", "left_simp_expr", "add_op", "term", "left_term", 
  "mult_op", "factor", "variable", "check_func", "special_func_call", 
  "stringcompare_call", "stringlength_call", "single_exprparm", 
  "receive_call", "sscanf_call", "sscanf_buf_fmt", "sscanf_parmlist", 
  "array_var", "array_id", "index_expr", "typecast", "ident", "newident", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    71,    71,    71,    72,    73,    73,    74,    74,    74,
      74,    74,    74,    74,    75,    75,    75,    76,    77,    78,
      79,    79,    80,    81,    81,    82,    83,    84,    85,    85,
      86,    86,    87,    87,    87,    87,    87,    87,    88,    89,
      88,    90,    91,    91,    92,    93,    93,    93,    93,    93,
      93,    93,    94,    95,    96,    96,    97,    98,    98,    98,
      99,   100,   101,   101,   102,   103,   104,   105,   106,   107,
     107,   108,   109,   110,   110,   111,   111,   112,   113,   113,
     114,   115,   116,   116,   117,   118,   119,   120,   121,   122,
     123,   123,   124,   124,   125,   125,   125,   126,   127,   128,
     129,   130,   131,   132,   132,   133,   134,   135,   136,   136,
     136,   136,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   137,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   148,   149,   150,   151,   151,   152,
     152,   153,   153,   154,   155,   156,   156,   156,   156,   156,
     157,   158,   158,   159,   160,   161,   161,   162,   163,   164,
     165,   166,   166,   167,   167,   168,   168,   168,   168,   168,
     168,   169,   169,   169,   169,   170,   171,   171,   171,   172,
     172,   173,   174,   174,   174,   174,   175,   175,   175,   175,
     175,   176,   176,   176,   176,   177,   178,   178,   178,   178,
     179,   180,   181,   181,   182,   182,   183,   184,   185,   185,
     186,   187,   188,   188,   189,   190,   191
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     2,     3,     2,     0,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     2,     1,
       1,     1,     5,     1,     2,     3,     3,     2,     0,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     3,     3,     1,     3,     1,     2,     2,     1,     2,
       2,     1,     1,     3,     3,     1,     3,     1,     1,     1,
       1,     7,     3,     1,     2,     2,     0,     4,     3,     3,
       1,     4,     1,     3,     1,     0,     2,     1,     3,     3,
       2,     3,     0,     1,     2,     2,     2,     3,     4,     2,
       0,     3,     3,     1,     1,     1,     1,     3,     4,     3,
       4,     3,     1,     1,     1,     3,     1,     1,     3,     1,
       2,     2,     0,     1,     1,     1,     1,     2,     4,     4,
       4,     2,     3,     2,     2,     1,     1,     1,     1,     2,
       4,     3,     1,     2,     3,     2,     3,     0,     3,     3,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       5,     2,     2,     2,     3,     3,     3,     1,     3,     4,
       5,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     3,     1,     1,     1,     1,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       2,     3,     1,     1,     1,     0,     1,     1,     1,     1,
       3,     2,     3,     3,     3,     5,     4,     5,     1,     3,
       4,     1,     3,     1,     4,     1,     1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       4,    82,     0,     0,     0,     0,     0,    83,    19,     0,
      82,     5,    13,    14,    15,    82,    16,     3,     0,     0,
       7,     0,    11,    10,    12,     8,    77,     0,    82,     0,
       0,    82,     9,    28,   216,     0,    43,     0,     0,    70,
       0,    72,    74,     0,    55,     0,     0,    27,    39,     6,
       2,     0,    18,    20,    21,    82,   106,   107,     0,     0,
      82,    38,    40,     0,    80,    29,    31,    32,    33,    34,
      35,    36,    37,     0,     0,     0,    90,     0,    90,     0,
      86,   102,     0,    41,     0,    68,     0,     0,    53,     0,
     101,     0,    23,    82,     0,     0,     0,     0,   215,     0,
     128,   126,     0,   132,     0,     0,   113,     0,   109,     0,
       0,     0,     0,   112,     0,     0,   114,     0,   115,   144,
     116,   145,   146,   147,   148,   149,     0,     0,     0,   143,
      25,    26,    78,    30,    89,    85,    81,     0,    84,    87,
       0,    79,   103,     0,   104,    42,    52,    51,     0,     0,
      44,    45,    48,    69,     0,     0,    75,    57,    58,    59,
      60,    73,    54,    56,    17,     0,    24,   111,   110,     0,
       0,     0,     0,     0,     0,     0,   188,     0,     0,     0,
       0,     0,     0,   187,   195,   123,   163,     0,   171,     0,
     179,   186,   192,   196,   197,   198,   199,     0,   193,   194,
     143,   129,     0,     0,   153,   105,   112,   112,   117,     0,
     127,     0,     0,   121,     0,     0,   133,   137,     0,     0,
       0,   135,     0,     0,     0,    93,    94,    95,    96,     0,
     100,    46,    49,    47,    50,     0,     0,     0,    71,    22,
     157,   151,   152,     0,   154,   158,     0,     0,   201,     0,
       0,   190,     0,   172,   173,     0,   137,   170,   168,   169,
     178,   165,   176,   177,   166,   167,     0,     0,   183,   184,
     185,   182,     0,     0,     0,     0,     0,   108,   124,   125,
     112,   112,     0,   131,     0,   122,     0,   136,     0,   161,
     134,   213,     0,     0,     0,     0,    91,    88,     0,     0,
       0,    63,     0,    76,     0,     0,     0,   200,     0,     0,
       0,   204,   189,   191,   164,     0,   174,   180,   208,     0,
       0,   203,   202,   118,   119,   120,   130,   142,     0,   140,
     141,     0,   159,   210,     0,     0,    99,    97,    92,    67,
      65,    66,     0,    64,   156,   155,   160,     0,   214,     0,
       0,   206,   150,     0,   138,   162,   212,    98,     0,    62,
     207,   205,   209,   139,     0,    61,     0,     0,     0
};

static const short yydefgoto[] =
{
     366,     1,    10,    11,    12,    13,    14,    15,    52,    16,
      93,    17,    18,    19,    64,    65,    66,    67,    21,    68,
      35,    36,   299,   183,    69,    43,    44,   156,   157,   158,
     300,   301,   302,   358,   159,    70,    38,    39,    40,    41,
     238,    71,    26,    27,    28,    29,    75,    76,    30,    31,
      77,    78,   138,   224,   225,   226,   227,   228,    72,    33,
      82,   143,   106,    58,    59,   107,   108,   109,   208,   280,
     110,   209,   111,   112,   113,   114,   115,   116,   117,   118,
     287,   328,   329,   184,   217,   120,   121,   170,   122,   123,
     244,   241,   124,   125,   126,   288,   330,   266,   186,   187,
     267,   188,   189,   272,   190,   191,   256,   192,   193,   194,
     204,   195,   196,   197,   319,   198,   128,   292,   199,   200,
      42
};

static const short yypact[] =
{
  -32768,   224,    38,    38,    38,    38,    38,-32768,-32768,   -32,
      88,-32768,-32768,-32768,-32768,   190,-32768,-32768,    77,    85,
  -32768,    20,-32768,-32768,-32768,-32768,-32768,    77,   170,    78,
      77,   170,-32768,   160,-32768,    87,-32768,     6,   103,-32768,
      74,    99,-32768,   114,-32768,   127,   147,-32768,-32768,-32768,
  -32768,    38,-32768,-32768,-32768,   172,-32768,-32768,   366,   167,
     170,-32768,-32768,   158,-32768,   160,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,   222,   228,   191,   182,   193,   182,   194,
  -32768,-32768,    -1,    38,    71,    38,   101,    38,    38,   101,
  -32768,   197,-32768,    96,   -17,   189,   189,   201,-32768,   304,
  -32768,-32768,   256,-32768,   189,   204,-32768,     5,-32768,   248,
     304,   400,   257,   492,   245,   427,-32768,   304,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,   223,   273,   230,     0,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,    23,-32768,-32768,
     229,-32768,-32768,   237,-32768,-32768,-32768,-32768,    83,    83,
  -32768,-32768,-32768,-32768,   233,   234,   279,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,    38,   242,-32768,-32768,-32768,   185,
     236,   236,   304,   189,   204,   238,-32768,   239,   331,   189,
     331,   331,   304,-32768,-32768,-32768,   425,   428,    26,    32,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,   244,-32768,-32768,
     240,-32768,   255,   249,-32768,-32768,   492,   492,   285,   270,
  -32768,    -9,   304,-32768,   304,    67,-32768,   254,   304,   304,
     304,-32768,    38,   258,    53,-32768,-32768,-32768,-32768,   256,
  -32768,-32768,-32768,-32768,-32768,    71,    71,    71,-32768,-32768,
  -32768,-32768,-32768,   185,-32768,-32768,   260,   236,-32768,   304,
     304,-32768,    18,    26,    26,   259,   254,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,   304,   331,-32768,-32768,
  -32768,-32768,   331,   304,   304,   262,   263,-32768,-32768,-32768,
     492,   492,   304,-32768,   288,-32768,   276,-32768,    97,-32768,
  -32768,-32768,   166,   266,    68,    23,-32768,-32768,   269,   298,
     169,-32768,    71,-32768,   268,   272,   320,-32768,   282,   280,
     304,-32768,-32768,-32768,    47,    57,    26,-32768,-32768,   120,
     281,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   129,-32768,
  -32768,   304,-32768,-32768,   304,   256,-32768,-32768,-32768,-32768,
  -32768,-32768,    71,-32768,-32768,-32768,-32768,   320,-32768,   283,
     304,-32768,-32768,   276,-32768,-32768,-32768,-32768,   322,-32768,
  -32768,-32768,-32768,-32768,   101,-32768,   333,   349,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,-32768,   342,-32768,-32768,-32768,-32768,   -44,-32768,
  -32768,   343,-32768,-32768,     9,-32768,   290,   137,-32768,   157,
  -32768,   274,   -75,   -82,   165,-32768,   271,   -88,-32768,-32768,
  -32768,    16,-32768,-32768,-32768,   173,   309,   -70,  -130,-32768,
  -32768,   175,-32768,-32768,     4,-32768,-32768,-32768,-32768,     8,
  -32768,-32768,   284,-32768,    66,-32768,-32768,-32768,   181,   348,
  -32768,-32768,    11,-32768,   186,    25,  -108,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
     110,-32768,    15,   -55,-32768,-32768,-32768,   -92,-32768,-32768,
    -144,  -235,-32768,-32768,-32768,-32768,   -93,-32768,   105,   107,
  -32768,  -167,-32768,-32768,  -168,-32768,-32768,-32768,-32768,-32768,
     195,-32768,-32768,-32768,-32768,   -38,-32768,-32768,-32768,   -58,
      28
};


#define	YYLAST		545


static const short yytable[] =
{
     129,   163,   151,   119,   171,   213,   185,   223,   304,   150,
     251,    92,   202,   253,   254,   153,    48,   210,   221,    53,
     127,   167,   282,    54,   216,    61,   152,   245,   160,    57,
      37,   160,    45,    46,    47,    34,    56,   142,    57,   168,
      80,    57,    81,   205,   201,  -181,  -181,   206,  -181,   166,
      34,   268,   269,   129,   270,   129,   119,   129,   119,    53,
     119,   206,  -211,    54,   222,    84,   231,   233,  -175,   131,
      62,   346,   336,   127,   146,   127,   242,   127,   260,   246,
      98,   247,   310,    98,   147,   311,   146,   252,    -1,   255,
     232,   234,   293,   144,   153,    98,  -181,    53,   277,   278,
     316,    54,   271,   307,   317,   154,   285,  -175,  -175,   295,
     276,    37,   360,    98,    56,   161,    45,   262,   263,   283,
     296,   284,    73,   206,    74,   289,   290,   291,     2,     3,
       4,   148,   149,     5,   165,     6,   211,     7,    20,    86,
     215,    60,     8,    83,   155,     7,     9,    20,   129,   129,
     305,   119,   119,   151,   151,   151,   308,   309,    22,    85,
     298,   331,   303,    87,   332,   223,    23,    22,   127,   127,
      88,   297,   323,   324,    24,    23,    25,   152,   152,   152,
     318,   320,    32,    24,   350,    25,    89,   351,   146,   325,
     240,    32,   173,   353,   174,   175,   354,    98,   176,   177,
       2,     3,     4,    90,   -82,     5,   -82,   -28,   178,     7,
       2,     3,     4,    63,   132,     5,    79,   349,     9,     7,
     151,     7,   129,   129,   130,   119,   119,   343,     9,   333,
     334,    51,   341,   342,   134,     5,   337,   179,   355,     7,
     135,   356,   127,   127,   152,   180,   181,   136,   137,   139,
     141,   182,   146,   164,   275,   169,   173,   362,   174,   175,
     151,    98,   176,   177,     2,     3,     4,   172,    98,     5,
     203,     6,   178,     7,   207,   212,   365,   357,     8,   146,
     214,   327,     9,   173,   152,   174,   175,   218,    98,   176,
     177,   219,   220,   230,   229,   235,   236,   237,   239,   178,
     243,   179,  -211,   281,   249,   250,   160,   146,   273,   180,
     181,   173,   279,   174,   175,   182,    98,   176,   177,   274,
     286,   326,   340,   294,   306,   240,   312,   178,   179,   321,
     322,   335,   339,   367,   146,   344,   180,   181,   173,   345,
     174,   175,   182,    98,   176,   177,   347,   348,   352,   368,
     361,   364,    49,    50,   178,   133,   179,   145,   359,   162,
      91,   338,   140,    55,   180,   181,   313,    94,   363,   248,
     182,   314,    95,   315,    96,     0,     0,    97,    98,     0,
       0,     0,     0,   179,     0,     0,     0,     0,     0,     0,
       0,    99,     0,     0,     0,     0,   100,   182,   101,     0,
     102,    94,   103,    56,  -112,     0,    95,     0,    96,     0,
       0,    97,    98,     0,     0,     0,     0,   104,     0,   105,
       0,     0,  -112,     0,     0,    99,     0,     0,    94,     0,
     100,  -112,   101,    95,   102,    96,   103,    56,    97,    98,
    -175,  -175,  -175,   257,   258,   259,  -175,     0,     0,   260,
       0,   104,    99,   105,     0,     0,  -112,   100,     0,   101,
       0,   102,     0,   103,    56,     0,  -112,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   104,     0,
     105,     0,     0,  -112,  -175,  -175,  -175,   261,   262,   263,
       0,     0,     0,  -175,  -175,     0,   264,   265,    95,     0,
      96,     0,     0,    97,    98,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    99,     0,     0,
       0,     0,   100,     0,   101,     0,   102,     0,   103,    56,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104,     0,   105
};

static const short yycheck[] =
{
      58,    89,    84,    58,    96,   113,    99,   137,   243,    84,
     178,    55,   104,   180,   181,    85,    48,   110,    18,    15,
      58,    38,    31,    15,   117,     5,    84,   171,    86,    18,
       2,    89,     4,     5,     6,    12,    37,    38,    27,    56,
      31,    30,    33,    38,   102,    19,    20,    56,    22,    93,
      12,    19,    20,   111,    22,   113,   111,   115,   113,    55,
     115,    56,    62,    55,    41,    59,   148,   149,    21,    60,
      50,   306,     4,   111,     3,   113,   169,   115,    21,   172,
      12,   173,    64,    12,    13,    67,     3,   179,     0,   182,
     148,   149,   222,    82,   164,    12,    70,    93,   206,   207,
     267,    93,    70,   247,   272,     4,    39,    60,    61,    56,
     203,    83,   347,    12,    37,    87,    88,    60,    61,   212,
      67,   214,    44,    56,    46,   218,   219,   220,    40,    41,
      42,    60,    61,    45,    38,    47,   111,    49,     1,    65,
     115,    56,    54,    56,    43,    49,    58,    10,   206,   207,
     243,   206,   207,   235,   236,   237,   249,   250,     1,    56,
     235,    64,   237,    64,    67,   295,     1,    10,   206,   207,
      56,   229,   280,   281,     1,    10,     1,   235,   236,   237,
     273,   274,     1,    10,    64,    10,    59,    67,     3,   282,
       5,    10,     7,    64,     9,    10,    67,    12,    13,    14,
      40,    41,    42,    56,    44,    45,    46,    37,    23,    49,
      40,    41,    42,    27,    56,    45,    30,   310,    58,    49,
     302,    49,   280,   281,    57,   280,   281,   302,    58,    63,
      64,    41,    63,    64,    12,    45,   294,    52,   331,    49,
      12,   334,   280,   281,   302,    60,    61,    56,    66,    56,
      56,    66,     3,    56,     5,    66,     7,   350,     9,    10,
     342,    12,    13,    14,    40,    41,    42,    66,    12,    45,
      66,    47,    23,    49,    26,    18,   364,   335,    54,     3,
      35,     5,    58,     7,   342,     9,    10,    64,    12,    13,
      14,    18,    62,    56,    65,    62,    62,    18,    56,    23,
      64,    52,    62,    33,    66,    66,   364,     3,    64,    60,
      61,     7,    27,     9,    10,    66,    12,    13,    14,    64,
      66,    33,    24,    65,    64,     5,    67,    23,    52,    67,
      67,    65,    63,     0,     3,    67,    60,    61,     7,    67,
       9,    10,    66,    12,    13,    14,    64,    67,    67,     0,
      67,    29,    10,    10,    23,    65,    52,    83,   342,    88,
      51,   295,    78,    15,    60,    61,   256,     1,   353,   174,
      66,   266,     6,   266,     8,    -1,    -1,    11,    12,    -1,
      -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    -1,    -1,    30,    66,    32,    -1,
      34,     1,    36,    37,    38,    -1,     6,    -1,     8,    -1,
      -1,    11,    12,    -1,    -1,    -1,    -1,    51,    -1,    53,
      -1,    -1,    56,    -1,    -1,    25,    -1,    -1,     1,    -1,
      30,    31,    32,     6,    34,     8,    36,    37,    11,    12,
      15,    16,    17,    15,    16,    17,    21,    -1,    -1,    21,
      -1,    51,    25,    53,    -1,    -1,    56,    30,    -1,    32,
      -1,    34,    -1,    36,    37,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      53,    -1,    -1,    56,    59,    60,    61,    59,    60,    61,
      -1,    -1,    -1,    68,    69,    -1,    68,    69,     6,    -1,
       8,    -1,    -1,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      -1,    -1,    30,    -1,    32,    -1,    34,    -1,    36,    37,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    51,    -1,    53
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 146 "bapascal.y"
{
         int i;
         tab[ob_tix].adr = lc;  /* outerblock entry pt */
         for (i = 0; i <= mon; i++){
             /* don't emit CALL_MONINIT for ext_monitor objects */
            if (tab[mtab[i]].obj == monitor) {
               emit1(MARKSTACK,mtab[i]-last_predeclared);
               emit(CALL_MONINIT);
            }
         }
         process_var_inits(level);
      ;
    break;}
case 2:
#line 159 "bapascal.y"
{ 
         if (!making_objfile&&!main_declared) 
            yyerror("No 'main' function declared");
         if (main_declared)
            emit(SHORTRET);
      ;
    break;}
case 3:
#line 166 "bapascal.y"
{ 
         if (!making_objfile&&!main_declared) 
            yyerror("No 'main' function declared");
         if (main_declared)
            emit(SHORTRET);
      ;
    break;}
case 4:
#line 175 "bapascal.y"
{   
         level = 0;
         enter(outerblock_name,outerblock,level,level);
         ob_tix = last_tab;
         /* initialize the block table index with the outer block*/
         tab[ob_tix].ref = last_btab = 0;
         btab[last_btab].lastpar = 0;
         btab[last_btab].psize = btab[last_btab].vsize = 0;
         /* initialize the static display */
         display[last_btab] = level;
      ;
    break;}
case 17:
#line 207 "bapascal.y"
{ external = 0; ;
    break;}
case 18:
#line 211 "bapascal.y"
{ 
         external = 0; 
      ;
    break;}
case 19:
#line 217 "bapascal.y"
{  external = 1; ;
    break;}
case 20:
#line 221 "bapascal.y"
{ leave_block(&level); ;
    break;}
case 21:
#line 223 "bapascal.y"
{ leave_block(&level); ;
    break;}
case 22:
#line 227 "bapascal.y"
{  
         tab[yyvsp[-3]].adr = -1;
         in_mon_decl = 0; 
         external = 0;
         leave_block(&level);
      ;
    break;}
case 25:
#line 240 "bapascal.y"
{
         int i;
         emit(HALT); 
         /* need to backpatch location of outer block code */
         /* in SHORTCALL instruction                       */
         code[outer_call_lc].y = lc; 
         tab[ob_tix].adr = lc;  /* outerblock entry pt */
         for (i = 0; i <= mon; i++){
            /* don't emit CALL_MONINIT for ext_monitor objects */
            if (tab[mtab[i]].obj == monitor) {
               emit1(MARKSTACK,mtab[i]-last_predeclared);
               emit(CALL_MONINIT);
            }
         }
         process_var_inits(level);
         process_var_inits(level-1);
      ;
    break;}
case 26:
#line 261 "bapascal.y"
{ 
         tab[yyvsp[-2]].adr = lc;          /* main pgm entry point */ 
         process_var_inits(level);  /* process any var inits */
         outer_call_lc = lc;        /* loc of SHORTCALL instr */
         emit(SHORTCALL);           /* target addr is backpatched later */
      ;
    break;}
case 27:
#line 270 "bapascal.y"
{ /* pgm name is last symbol in outer scope */
         yyval = yyvsp[0];
         main_declared = 1;
         external = 0;
         tab[last_tab].obj = mainproc;
         prt = last_tab;
         btab[0].lastpar = prt;  /* save main's tabix for the interp */
         enter_block(&last_btab,&level,last_tab);
         btab[last_btab].lastpar = last_tab; /* no parms */
      ;
    break;}
case 38:
#line 299 "bapascal.y"
{
         if (strcmp(laststring,infile[curr_infile].fname) == 0) 
            yyerror("Recursive file inclusion");
         else {
            curr_infile = open_infile(laststring,curr_infile);
            yyin = infile[curr_infile].f;
         }
         in_include = 0;
      ;
    break;}
case 39:
#line 311 "bapascal.y"
{ 
         in_include = 1;
      ;
    break;}
case 40:
#line 317 "bapascal.y"
{
         if (strcmp(laststring,infile[curr_infile].fname) == 0) 
            yyerror("Recursive file inclusion");
         else {
            curr_infile = open_infile(laststring,curr_infile);
            yyin = infile[curr_infile].f;
         }
         in_include = 0;
      ;
    break;}
case 44:
#line 336 "bapascal.y"
{
         tab[last_tab].typ = consttype;
         tab[last_tab].adr = yyvsp[0]; 
         tab[last_tab].ref = 0;
      ;
    break;}
case 45:
#line 344 "bapascal.y"
{ consttype = ints; ;
    break;}
case 46:
#line 346 "bapascal.y"
{ yyval = yyvsp[0]; consttype = ints; ;
    break;}
case 47:
#line 348 "bapascal.y"
{ yyval = - yyvsp[0]; consttype = ints; ;
    break;}
case 48:
#line 350 "bapascal.y"
{  yyval = get_constant(lastident,level,&consttype); ;
    break;}
case 49:
#line 352 "bapascal.y"
{  yyval = get_constant(lastident,level,&consttype);
            if (consttype != ints) {
               sprintf(pbuf,"Identifier '%s' not INTEGER type",lastident);
               yyerror(pbuf);
               consttype = notyp;
            }
         ;
    break;}
case 50:
#line 360 "bapascal.y"
{  yyval = - get_constant(lastident,level,&consttype);
            if (consttype != ints) {
               sprintf(pbuf,"Identifier '%s' not INTEGER type",lastident);
               yyerror(pbuf);
               consttype = notyp;
            }
         ;
    break;}
case 51:
#line 368 "bapascal.y"
{ consttype = chars; yyval = laststring[0]; ;
    break;}
case 52:
#line 372 "bapascal.y"
{yyval = strtoi(numbertext,numberbase);;
    break;}
case 56:
#line 383 "bapascal.y"
{
         tab[yyvsp[-2]].obj = type;
         if (expr[yyvsp[0]].typ == arrays) {
            tab[yyvsp[-2]].typ = arrays;
            tab[yyvsp[-2]].ref = expr[yyvsp[0]].ref;  /* its atab index */
            /* atab sizes are in stack words */
            /* adr field is in bytes */
            tab[yyvsp[-2]].adr = sizeof(int)*atab[expr[yyvsp[0]].ref].size;
         }
         else { /* for non-arrays, the expr info is handled identically */
            tab[yyvsp[-2]].typ = expr[yyvsp[0]].typ;
            tab[yyvsp[-2]].ref = expr[yyvsp[0]].ref; 
            tab[yyvsp[-2]].adr = expr[yyvsp[0]].adr;
         }
         free_expr(yyvsp[0]);
      ;
    break;}
case 60:
#line 407 "bapascal.y"
{  
         if (yyvsp[0] != 0) {
            if ((tab[yyvsp[0]].obj != type)||(tab[yyvsp[0]].typ == notyp)){
               sprintf(pbuf,"Identifier '%s' is not a valid type",lastident);
               yyerror(pbuf);
               yyval = NO_EXPR;
            }
            else  {
               yyval = new_expr();
               expr[yyval].tix = yyvsp[0];
               expr[yyval].adr = tab[yyvsp[0]].adr;
               expr[yyval].typ = tab[yyvsp[0]].typ;
               expr[yyval].ref = tab[yyvsp[0]].ref;
               expr[yyval].lev = tab[yyvsp[0]].lev;
               expr[yyval].normal = tab[yyvsp[0]].normal;
               expr[yyval].arelt = 0;
            }
         }            
         else /* wasn't there, loc has already complained */
            yyval = NO_EXPR;
      ;
    break;}
case 61:
#line 432 "bapascal.y"
{  
      int i;
      TYPES eltyp;
      int   elsize,elref,last;
         yyval = new_expr();
         expr[yyval].obj = type;
         expr[yyval].typ = arrays;
         expr[yyval].ref = yyvsp[-4]; /* atab index is passed up through index_type */
         if (expr[yyvsp[0]].typ == arrays) { /* type production has atab index */
            i = expr[yyvsp[0]].ref; /* get the atab index */
            elsize = atab[i].size;  /* atab has size in stack words */
            eltyp = arrays;
            last = yyvsp[-2];     /* last dimension atab */
            elref = i;
         }
         else if (expr[yyvsp[0]].typ == strings) {
               /* ref field of string is size in bytes */
            elsize = stacksize(expr[yyvsp[0]].ref);
            eltyp = strings;
            elref = 0;  /* last non-array elref in atab must be 0 */
            last = last_atab;
         } 
         else { /* type production has tab index and isn't typ arrays */
            i = expr[yyvsp[0]].tix;    /* get tab index */
            elsize = stacksize(tab[i].adr);/* adr is byte size of type object */
            eltyp = tab[i].typ;
            elref = 0;  /* last non-array elref in atab must be 0 */
            last = last_atab;
         }
         for (i= last; i >= yyvsp[-4]; i--){ /* work from 'back to front' */
            atab[i].elref = elref;
            atab[i].elsize = elsize;
            atab[i].size = (1 + atab[i].high - atab[i].low)*elsize;
            elsize = atab[i].size;
            atab[i].eltyp = eltyp;
            eltyp = arrays;
            elref = i;
         }
         free_expr(yyvsp[0]);
      ;
    break;}
case 64:
#line 481 "bapascal.y"
{
         if (consttype != atab[last_atab].inxtyp)
            yyerror("Array index type mismatch");
         else {
            if (yyvsp[0] < atab[last_atab].low){
               sprintf(pbuf,"Upper array index %d less than lower index %d",
                  yyvsp[0],atab[last_atab].low);
               yyerror(pbuf);
            }
            else
               atab[last_atab].high = yyvsp[0];
         }
         yyval = last_atab;
      ;
    break;}
case 65:
#line 498 "bapascal.y"
{
         if (last_atab == AMAX) 
            cfatal("Array table full with %d entries",AMAX);
         atab[++last_atab].inxtyp = consttype;
         atab[last_atab].high = atab[last_atab].low = yyvsp[-1];
         yyval = last_atab;  /* pass the array start up the parse tree */
      ;
    break;}
case 66:
#line 508 "bapascal.y"
{  yyval = last_atab; ;
    break;}
case 67:
#line 512 "bapascal.y"
{
         yyval = new_expr();
         if (consttype != ints)
            yyerror("Size of 'string' type must be an integer");
         else if (yyvsp[-1] <= 0)
            yyerror("Size of 'string' type must be positive");
         else {
            expr[yyval].ref = 1 + yyvsp[-1];  /* allow for null terminator */
            expr[yyval].typ = strings;
            expr[yyval].obj = type;
         }
      ;
    break;}
case 71:
#line 534 "bapascal.y"
{  
      int i,vartyp,varref,varsize,dx = btab[display[level]].vsize;
      int val;
         if (yyvsp[0] != NO_EXPR) {
            val = expr[yyvsp[0]].adr;
            if (expr[yyvsp[-1]].typ == conds)
               yyerror("Cannot assign to a 'condition'");
            else if (expr[yyvsp[-1]].typ == bsems) {
               if ((expr[yyvsp[0]].typ != ints)||(val < 0)||(val > 1)) 
                  yyerror("A binary semaphore can only become 0 or 1");
            }
            else if (expr[yyvsp[-1]].typ == sems) {
               if (expr[yyvsp[0]].typ != ints)
                  yyerror("integer initialization value expected");
               else if (val < 0)
                  yyerror("A semaphore cannot be negative");
            }
            else if ((expr[yyvsp[-1]].typ != ints) && (expr[yyvsp[-1]].typ != chars) &&
               (expr[yyvsp[-1]].typ != bools))  
               yyerror("'INTEGER', 'CHAR', or 'BOOLEAN' type expected");
            else if (expr[yyvsp[-1]].typ != expr[yyvsp[0]].typ)
               yyerror("Type of initializer does not match variable type");
            if (external)
               yyerror("External variables cannot be initialized");
         }
         else
            val = 0;
         if (expr[yyvsp[-1]].typ == arrays) { /* type production has atab index */
            varsize = atab[expr[yyvsp[-1]].ref].size;
            vartyp = arrays;
            varref = expr[yyvsp[-1]].ref;
         }
         else if (expr[yyvsp[-1]].typ == strings){
            varsize = stacksize(expr[yyvsp[-1]].ref);
            vartyp = strings;
            varref = expr[yyvsp[-1]].ref;
         }
         else {  /* type production has tab index */ 
            varsize = stacksize(expr[yyvsp[-1]].adr);
            vartyp = expr[yyvsp[-1]].typ;
            varref = expr[yyvsp[-1]].ref;

         }
         for (i=yyvsp[-3]; i<= last_tab; i++){
            tab[i].typ = vartyp;
            tab[i].ref = varref;
            tab[i].adr = dx;
            tab[i].obj = (external ? ext_variable : variable);
            if (yyvsp[0] != NO_EXPR){
               if (((in_mon_decl)&&(!in_proc_decl))||  /* global mon  vars */
                   ((level == 0)&&(!main_declared))||  /* outer global vars */
                   ((level == 1)&&(main_declared))||   /* main global vars */
                   (in_proc_decl)){ /* in a proc or func decl */
                  /* in these cases, must generate the init code later */
                  add_var_init(&curr_var,i,level,val); 
               }
            }
            dx += varsize;
         }
         btab[display[level]].vsize = dx;
         free_expr(yyvsp[-1]);  free_expr(yyvsp[0]);
      ;
    break;}
case 74:
#line 602 "bapascal.y"
{ yyval = yyvsp[0]; ;
    break;}
case 75:
#line 606 "bapascal.y"
{ yyval = NO_EXPR; ;
    break;}
case 76:
#line 608 "bapascal.y"
{
         yyval = new_expr();
         expr[yyval].typ = consttype;
         expr[yyval].adr = yyvsp[0];
      ;
    break;}
case 78:
#line 619 "bapascal.y"
{ 
         if (tab[yyvsp[-2]].mon) emit(EXITMON);
         emit(EXIT_PROC);
         leave_block(&level);
         in_proc_decl = 0;
      ;
    break;}
case 79:
#line 626 "bapascal.y"
{ 
         if (tab[yyvsp[-2]].mon) emit(EXITMON);
         emit(EXIT_FCN);
         leave_block(&level);
         in_proc_decl = 0;
      ;
    break;}
case 80:
#line 635 "bapascal.y"
{
         tab[yyvsp[-1]].adr = (external? -1 : lc);
         if (tab[yyvsp[-1]].mon) emit1(ENTERMON,tab[yyvsp[-1]].mon); 
         process_var_inits(level);
      ;
    break;}
case 81:
#line 643 "bapascal.y"
{
         yyval = yyvsp[-1];
         tab[yyvsp[-1]].atomic = atomic;
      ;
    break;}
case 82:
#line 650 "bapascal.y"
{ atomic = FALSE; ;
    break;}
case 83:
#line 652 "bapascal.y"
{ atomic = TRUE; ;
    break;}
case 85:
#line 660 "bapascal.y"
{ int vis_level,real_level;
         in_proc_decl = 1;
         if (in_mon_decl) {
            real_level = level;
            vis_level = ((level > 0) ? level -1 : 0);
         }
         else {
            vis_level = real_level = level;
         }
         yyval = prt = enter(lastident, (external? ext_procedure : procedure)
                              ,real_level,vis_level);
         if (in_mon_decl) tab[prt].mon = mtab[mon] - last_predeclared;
         enter_block(&last_btab,&level,prt);
      ;
    break;}
case 86:
#line 677 "bapascal.y"
{
         tab[yyvsp[-1]].adr = (external? -1 : lc);
         if (tab[yyvsp[-1]].mon) emit1(ENTERMON,tab[yyvsp[-1]].mon); 
         process_var_inits(level);
      ;
    break;}
case 87:
#line 685 "bapascal.y"
{
         tab[yyvsp[-1]].atomic = atomic;
         yyval = yyvsp[-1];
      ;
    break;}
case 88:
#line 692 "bapascal.y"
{ TYPES ft = tab[yyvsp[0]].typ; 
         if (tab[yyvsp[0]].obj != type){
            sprintf(pbuf,"'%s' is not a valid type",tab[yyvsp[0]].name);
            yyerror(pbuf);
         }
         if ((ft != ints)&&(ft != bools)&&(ft != chars)&&(ft != notyp)) 
            yyerror("Function return type must be INTEGER, BOOLEAN, or CHAR");
         tab[yyvsp[-3]].typ = tab[yyvsp[0]].typ;
      ;
    break;}
case 89:
#line 704 "bapascal.y"
{ int vis_level,real_level;
         in_proc_decl = 1;
         if (in_mon_decl) {
            real_level = level;
            vis_level = ((level > 0) ? level -1 : 0);
         }
         else {
            vis_level = real_level = level;
         }
         yyval = prt = enter(lastident, (external? ext_function: function)
                           ,real_level,vis_level);
         if (in_mon_decl) tab[prt].mon = mtab[mon];
         enter_block(&last_btab,&level,prt);
      ;
    break;}
case 90:
#line 721 "bapascal.y"
{ btab[display[level]].lastpar = last_tab;;
    break;}
case 91:
#line 723 "bapascal.y"
{ btab[display[level]].lastpar = last_tab;;
    break;}
case 97:
#line 736 "bapascal.y"
{ int i,dx,dv,j,elem_size,stack_dx;
         if (tab[yyvsp[0]].obj != type) {
            sprintf(pbuf,"'%s' is not a valid type",tab[yyvsp[0]].name);
            yyerror(pbuf);
         }
         j = display[level];
         elem_size = tab[yyvsp[0]].adr;
         stack_dx = stacksize(elem_size);
         dx = btab[j].vsize;
         dv = dx - btab[j].psize; /* in case vbls have been declared */
         for (i = yyvsp[-2]; i <= last_tab; i++) {
            tab[i].typ = tab[yyvsp[0]].typ;
            tab[i].ref = tab[yyvsp[0]].ref;
            tab[i].lev = level;
            tab[i].obj = variable;
            tab[i].adr = dx;
            dx = stack_dx + dx;
         }
         btab[j].psize = dx;
         btab[j].vsize = dx + dv;
      ;
    break;}
case 98:
#line 760 "bapascal.y"
{ int i,dx,dv,j,elem_size;
         if (tab[yyvsp[0]].obj != type) {
            sprintf(pbuf,"'%s' is not a valid type",tab[yyvsp[0]].name);
            yyerror(pbuf);
         }
         j = display[level];
         elem_size = tab[yyvsp[0]].adr; 
         dx = btab[j].vsize;
         dv = dx - btab[j].psize; /* in case vbls have been declared */
         for (i = yyvsp[-2]; i <= last_tab; i++) {
            tab[i].typ = tab[yyvsp[0]].typ;
            tab[i].ref = tab[yyvsp[0]].ref;
            tab[i].lev = level;
            tab[i].obj = variable;
            tab[i].adr = dx;
            tab[i].normal = FALSE; /* VAR parms are not normal */
            dx++;                  /* pointers occupy 1 stack word */
         }
         btab[j].psize = dx;
         btab[j].vsize = dx + dv;
      ;
    break;}
case 99:
#line 784 "bapascal.y"
{ int i,dx,dv,j,stack_dx;
         j = display[level];
         stack_dx = 1;            /* strings always pass by reference */
         dx = btab[j].vsize;
         dv = dx - btab[j].psize; /* in case vbls have been declared */
         for (i = yyvsp[-2]; i <= last_tab; i++) {
            tab[i].typ = strings;
            tab[i].ref = 0;
            tab[i].normal = 0;   /* pass by reference */
            tab[i].lev = level;
            tab[i].obj = variable;
            tab[i].adr = dx;
            dx = stack_dx + dx;
         }
         btab[j].psize = dx;
         btab[j].vsize = dx + dv;
      ;
    break;}
case 100:
#line 804 "bapascal.y"
{
         if (tab[mtab[mon]].obj == monitor) {
            /* don't do the following for ext_monitor objects */
            /* main pgm will CALL_MONINIT, even if no init code */
            emit(RET_MONINIT); 
         }
         leave_block(&level);
      ;
    break;}
case 101:
#line 815 "bapascal.y"
{
         if (mon == MAXMON) 
            cfatal("No more than %d monitors can be declared",MAXMON);
         if (level > 1) {
            sprintf(pbuf,
            "Monitors must be declared at level 1 or level 0, not level %d\n",
            level);
            yyerror(pbuf);
         }
         tab[yyvsp[-1]].obj = (external ? ext_monitor : monitor);
         mtab[++mon] = yyvsp[-1];
         in_mon_decl = 1;
         yyval = yyvsp[-1];
         enter_block(&last_btab,&level,last_tab);
         btab[last_btab].lastpar = last_tab;  /* no parms */
      ;
    break;}
case 102:
#line 834 "bapascal.y"
{
         in_mon_decl = 0;  /* optional declarations are over */
         in_mon_init = 1;  /* could have some init code     */
      ;
    break;}
case 103:
#line 841 "bapascal.y"
{
         tab[mtab[mon]].adr = lc;
         process_var_inits(level);
         in_mon_init = 0; 
      ;
    break;}
case 106:
#line 853 "bapascal.y"
{
         if (in_mon_init) {   /* beginning of the mon init code */
            tab[mtab[mon]].adr = lc;
            process_var_inits(level);
            in_mon_init = 0; 
         } 
      ;
    break;}
case 110:
#line 868 "bapascal.y"
{ yyerrok; ;
    break;}
case 111:
#line 870 "bapascal.y"
{ yyerrok; ;
    break;}
case 117:
#line 879 "bapascal.y"
{ code[yyvsp[-1]].y = yyvsp[0]; ;
    break;}
case 118:
#line 881 "bapascal.y"
{ code[yyvsp[-3]].y = yyvsp[-1]; code[yyvsp[-2]].y = lc; ;
    break;}
case 119:
#line 883 "bapascal.y"
{ emit1(JUMP,yyvsp[-3]); code[yyvsp[-2]].y = lc; ;
    break;}
case 120:
#line 885 "bapascal.y"
{ gen_exprval(yyvsp[0]); emit1(JZER,yyvsp[-3]); free_expr(yyvsp[0]); ;
    break;}
case 121:
#line 887 "bapascal.y"
{ emit1(ENDFOR,1+yyvsp[-1]); code[yyvsp[-1]].y = lc; ;
    break;}
case 122:
#line 890 "bapascal.y"
{ if (level == 1) emit(COEND); in_cobegin = 0; ;
    break;}
case 123:
#line 894 "bapascal.y"
{ gen_exprval(yyvsp[0]); yyval = lc; emit(JZER); free_expr(yyvsp[0]); ;
    break;}
case 124:
#line 898 "bapascal.y"
{ yyval = lc; ;
    break;}
case 125:
#line 902 "bapascal.y"
{ emit(JUMP); yyval = lc; ;
    break;}
case 126:
#line 906 "bapascal.y"
{ yyval = lc; ;
    break;}
case 127:
#line 910 "bapascal.y"
{ gen_exprval(yyvsp[0]); free_expr(yyvsp[0]); yyval = lc; emit(JZER);;
    break;}
case 128:
#line 914 "bapascal.y"
{ yyval = lc; ;
    break;}
case 129:
#line 918 "bapascal.y"
{
         yyval = yyvsp[0];
         if (tab[yyvsp[0]].obj != variable) 
            yyerror("FOR loop index must be a VARIABLE");
         if (!tab[yyvsp[0]].normal) 
            yyerror("FOR loop index cannot be a VAR parameter");
         emit2(LOAD_ADDR,tab[yyvsp[0]].lev,tab[yyvsp[0]].adr);
         if ((tab[yyvsp[0]].typ != ints)&&(tab[yyvsp[0]].typ != bools)&&
             (tab[yyvsp[0]].typ != chars)&&(tab[yyvsp[0]].typ != notyp))
            yyerror("FOR loop index must be of type INTEGER, BOOLEAN, or CHAR");
      ;
    break;}
case 130:
#line 932 "bapascal.y"
{
         if (expr[yyvsp[-3]].typ != expr[yyvsp[-1]].typ)
            yyerror("Type mismatch in FOR loop limits");
         gen_exprval(yyvsp[-1]);
         yyval = lc; emit(BEGINFOR);
         free_expr(yyvsp[-3]); free_expr(yyvsp[-1]);
      ;
    break;}
case 131:
#line 942 "bapascal.y"
{
         if ((tab[yyvsp[-2]].typ != expr[yyvsp[0]].typ)&&(tab[yyvsp[-2]].typ != notyp))
            yyerror("Type mismatch in FOR loop limits");
         gen_exprval(yyvsp[0]);
         yyval = yyvsp[0]; /* pass expr index back to previous rule for type chk*/
      ;
    break;}
case 132:
#line 951 "bapascal.y"
{
         if (level != 1)
            yyerror("COBEGIN-COEND block allowed only in main program");
         else if (in_cobegin)
            yyerror("COBEGIN-COEND blocks cannot be nested");
         else
            emit(COBEGIN);
         in_cobegin = 1;
      ;
    break;}
case 133:
#line 963 "bapascal.y"
{
         gen_exprval(yyvsp[0]);
         if (tab[yyvsp[-1]].typ == expr[yyvsp[0]].typ) {
            if ((tab[yyvsp[-1]].typ == sems)||(tab[yyvsp[-1]].typ == bsems)|| 
                (tab[yyvsp[-1]].typ == conds))
               yyerror("Cannot assign to SEMAPHORE or CONDITION");
            else if (tab[yyvsp[-1]].typ == arrays)
               emit1(COPY_BLOCK,atab[tab[yyvsp[-1]].ref].size);
            else  /* standard types */
               emit(STORE);
         }
         else
            yyerror("Type mismatch in assignment");
         free_expr(yyvsp[0]);
      ;
    break;}
case 134:
#line 979 "bapascal.y"
{
         gen_exprval(yyvsp[0]);
         if (expr[yyvsp[-2]].typ == expr[yyvsp[0]].typ) {
            if ((expr[yyvsp[-2]].typ == sems)||(expr[yyvsp[-2]].typ == bsems)|| 
                (expr[yyvsp[-2]].typ == conds))
               yyerror("Cannot assign to SEMAPHORE or CONDITION");
            else if (expr[yyvsp[-2]].typ == arrays)
               emit1(COPY_BLOCK,atab[expr[yyvsp[-2]].ref].size);
            else
               emit(STORE);
         }
         else
            yyerror("Type mismatch in assignment");
         free_expr(yyvsp[-2]); free_expr(yyvsp[0]);
      ;
    break;}
case 135:
#line 997 "bapascal.y"
{
         switch (tab[yyvsp[-1]].obj) {
         case ext_variable:
         case variable:
            if ((tab[yyvsp[-1]].typ == sems)||(tab[yyvsp[-1]].typ == sems))
               yyerror("Must use INITIALSEM to initialize a SEMAPHORE");
            else
               emit2((tab[yyvsp[-1]].normal ? LOAD_ADDR : LOAD_VALUE),
                  tab[yyvsp[-1]].lev,tab[yyvsp[-1]].adr);
            break;
         case ext_function:
         case function:
            if ((tab[yyvsp[-1]].lev+1) == level) /* fn name declared in outer scope */
               /* s[display[tab[$1].lev+1]+0] is loc of fn return value */
               emit2(LOAD_ADDR,tab[yyvsp[-1]].lev+1,0);
            else
               yyerror("FUNCTION identifier inaccessible at this level");
            break;
         default:
            yyerror("VARIABLE or FUNCTION identifier expected");
         } /* switch */
      ;
    break;}
case 136:
#line 1022 "bapascal.y"
{ int k;
         if ((tab[yyvsp[-2]].obj == procedure)||
             (tab[yyvsp[-2]].obj == ext_procedure)) {
            if (tab[yyvsp[-2]].lev == -1) { /* std proc unfinished business */
               stdproc_pcode(yyvsp[-2],parmct);
            } /* if std proc */
            else { /* regular proc call */
               /* first check on too few parms */
               k = btab[tab[yyvsp[-2]].ref].lastpar - yyvsp[-2];
               if ((k > parmct)&&(first_parmcterr)) {
                  yyerror("Too few actual parameters in the call");
                  first_parmcterr = 0;
               }
               k = btab[tab[yyvsp[-2]].ref].psize - 1;
               if (tab[yyvsp[-2]].mon == 0)
                  emit2(CALL,0,k);
               else
                  emit2(CALL,-1,k); /* CALL pcode: x == -1 => mon call */
               if (tab[yyvsp[-2]].lev < level) /* update display, ord nesting*/
                  emit2(UPDATE_DISPLAY,tab[yyvsp[-2]].lev,level);
               else if ((tab[yyvsp[-2]].mon)&&(level == tab[yyvsp[-2]].lev))
               /* must fix display differently for monitor call */
                  emit2(UPDATE_DISPLAY,level-1,level);
            } /* else regular proc */
            toppfs--;
            if (toppfs < 0 )
               parmct = last_pf = 0;
            else {
               parmct = pfstack[toppfs].pct;
               last_pf = pfstack[toppfs].tix;
            }
         }
      ;
    break;}
case 141:
#line 1066 "bapascal.y"
{
         parmct = ++pfstack[toppfs].pct;
         if (tab[last_pf].lev == -1)
            stdproc_parm(last_pf,yyvsp[0],parmct);
         else
            proc_parm(last_pf,yyvsp[0],parmct);
         free_expr(yyvsp[0]);
      ;
    break;}
case 142:
#line 1075 "bapascal.y"
{ int tmp = store_string(laststring,&stab_size);
         if ((tab[last_pf].lev == -1)&&
            ((tab[last_pf].adr == SP_WRITE)||
             (tab[last_pf].adr == SP_WRITELN))){
               emit1(WRITE_RAWSTRING,tmp);
         }
         else if (first_stringerr){
            yyerror("RAW STRING parameter not allowed");
            first_stringerr = 0;
         }
         parmct++;
      ;
    break;}
case 143:
#line 1090 "bapascal.y"
{ yyval = last_pfv = yyvsp[0]; ;
    break;}
case 144:
#line 1094 "bapascal.y"
{
         if ((tab[last_pfv].obj == procedure)||
             (tab[last_pfv].obj == ext_procedure)){
            if ((++toppfs) > 0){
               yyerror("Procedure calls can't be nested");
               pfstack[toppfs].tix = last_pf = last_pfv;
               pfstack[toppfs].pct = parmct = 0;
            }
            else{
               pfstack[toppfs].tix = last_pf = last_pfv;
               pfstack[toppfs].pct = parmct = 0;
               first_stringerr = first_parmcterr = 1;
               if (tab[last_pf].lev != -1){ /* regular proc call */
                  if ((tab[last_pf].mon)&&(tab[prt].mon)&&
                      (tab[last_pf].mon != tab[prt].mon))
                     yyerror("Cross monitor calls not allowed");
                  emit1(MARKSTACK,last_pf-last_predeclared);
               } /* if regular proc */
            } /* non-nested proc call */ 
         } /* if proc */
         else{
            yyerror("PROCEDURE call expected");
         }
      ;
    break;}
case 150:
#line 1128 "bapascal.y"
{
            yyval = new_expr();
            expr[yyval].obj = function;
            expr[yyval].typ = ints;
            expr[yyval].normal = 1; /* the value will be left on the stack */
            expr[yyval].ref = 0;
               /* make sure no one uses these */
            expr[yyval].adr = expr[yyval].lev = -1;
            if (expr[yyvsp[-1]].typ != ints)
               yyerror("right parameter is not of type 'int'");
            else {
                  /* put the value of the id expr on the stack */
               gen_exprval(yyvsp[-1]);
               if (expr[yyvsp[-3]].typ == rawstrings)     /* raw str message */
                  emit1(SEND_RAWSTRING,expr[yyvsp[-3]].adr);
               else if (expr[yyvsp[-3]].typ == ints)      /* int message */
                  emit(SEND_INT);
               else if (expr[yyvsp[-3]].typ == strings)   /* msg is a string var */
                  emit(SEND_STRING);
               else
                  yyerror("parameter is not 'rawstring', 'string', or 'int'");
            }
            free_expr(yyvsp[-3]); free_expr(yyvsp[-1]);
         ;
    break;}
case 151:
#line 1155 "bapascal.y"
{ yyval = yyvsp[0]; ;
    break;}
case 152:
#line 1157 "bapascal.y"
{ 
            if (expr[yyvsp[0]].typ == strings) {
               /* left parm is a string. If it's not an array elt, */
               /* put the address of the string n the stack        */
               if (!expr[yyvsp[0]].arelt)
                  emit_push_addr(expr[yyvsp[0]]);
            }
            else if (expr[yyvsp[0]].typ == ints) 
               gen_exprval(yyvsp[0]);  /* put the int on the stack */
            yyval = yyvsp[0];
         ;
    break;}
case 153:
#line 1171 "bapascal.y"
{
            if (expr[yyvsp[0]].typ == rawstrings)     /* raw str message */
               emit1(BROADCAST_RAWSTRING,expr[yyvsp[0]].adr);
            else if (expr[yyvsp[0]].typ == strings)   /* msg is a string var */
               emit(BROADCAST_STRING);
            else if (expr[yyvsp[0]].typ == ints)      /* int msg */
               emit(BROADCAST_INT);
            else
               yyerror("parameter is not 'rawstring', 'string', or 'int'");
            free_expr(yyvsp[0]); 
         ;
    break;}
case 154:
#line 1185 "bapascal.y"
{
         if (expr[yyvsp[-1]].typ != strings)
            yyerror("left parameter is not of type 'string'");
         yyval = NO_EXPR;     /* for free_expr() call up the parse tree */
         if (expr[yyvsp[0]].typ == rawstrings) 
            emit1(CONCAT_RAWSTRING,expr[yyvsp[0]].adr);
         else 
            emit(CONCAT_STRING);
         free_expr(yyvsp[-1]); free_expr(yyvsp[0]);
      ;
    break;}
case 155:
#line 1198 "bapascal.y"
{
         if (expr[yyvsp[-1]].typ != strings) {
            yyerror("right parameter is not of type 'string'");
         }
         else {
            if (!expr[yyvsp[-1]].arelt)
               /* push addr of source string */
               /* addr of array ref is already on the stack */
               emit_push_addr(expr[yyvsp[-1]]);
         }
      ;
    break;}
case 156:
#line 1210 "bapascal.y"
{ yyval = yyvsp[-1]; ;
    break;}
case 157:
#line 1214 "bapascal.y"
{
         yyval = new_expr();
         expr[yyval].obj = variable;
         expr[yyval].typ = rawstrings;
         expr[yyval].adr = store_string(laststring,&stab_size);
         expr[yyval].ref = 1 + strlen(laststring); /* includes null char */
         expr[yyval].normal = 1;
         expr[yyval].tix = -1;
      ;
    break;}
case 158:
#line 1227 "bapascal.y"
{
         if (expr[yyvsp[-1]].typ != strings)
            yyerror("left parameter is not of type 'string'");
         yyval = NO_EXPR;     /* for free_expr() call up the parse tree */
         if (expr[yyvsp[0]].typ == rawstrings) 
            emit1(COPY_RAWSTRING,expr[yyvsp[0]].adr);
         else 
            emit(COPY_STRING);
         free_expr(yyvsp[-1]); free_expr(yyvsp[0]);
      ;
    break;}
case 159:
#line 1240 "bapascal.y"
{
            /* push the parm count for interp's SPRINTF_OP to use */
            emit1(PUSH_LIT,sprintf_cnt); 
            emit1(SPRINTF_OP,yyvsp[-3]);
         ;
    break;}
case 160:
#line 1248 "bapascal.y"
{ 
            if (expr[yyvsp[-2]].typ != strings)
               yyerror("Leftmost sprintf parameter must be of type 'string'");
            yyval = expr[yyvsp[0]].adr;   /* pass raw string index up the tree */
            emit_push_addr(expr[yyvsp[-2]]);
            free_expr(yyvsp[-2]); free_expr(yyvsp[0]);
            sprintf_cnt = 0;
         ;
    break;}
case 161:
#line 1259 "bapascal.y"
{  
            if ((expr[yyvsp[0]].typ != ints)&&(expr[yyvsp[0]].typ != strings))
               yyerror(
            "sprintf parameter must be either of type 'int' or type 'string'");
            if (expr[yyvsp[0]].typ == strings)
               emit_push_addr(expr[yyvsp[0]]);
            else
               gen_exprval(yyvsp[0]);
            sprintf_cnt++;
            free_expr(yyvsp[0]);
         ;
    break;}
case 162:
#line 1271 "bapascal.y"
{  
            if ((expr[yyvsp[0]].typ != ints)&&(expr[yyvsp[0]].typ != strings))
               yyerror(
            "sprintf parameter must be either of type 'int' or type 'string'");
            if (expr[yyvsp[0]].typ == strings)
               emit_push_addr(expr[yyvsp[-2]]);
            else
               gen_exprval(yyvsp[0]);
            sprintf_cnt++;
            free_expr(yyvsp[0]);
         ;
    break;}
case 164:
#line 1286 "bapascal.y"
{
         gen_exprval(yyvsp[0]);
         if (expr[yyvsp[-2]].typ == expr[yyvsp[0]].typ){
            if ((expr[yyvsp[-2]].typ == ints)||(expr[yyvsp[-2]].typ == bools)||
                (expr[yyvsp[-2]].typ == chars))
               emit(yyvsp[-1]);
            else
               yyerror("Only INTEGER, BOOLEAN, CHAR types can be compared");
         }
         else
            yyerror("Types in comparison are unequal");
         expr[yyvsp[-2]].typ = bools;
         free_expr(yyvsp[0]);
      ;
    break;}
case 165:
#line 1302 "bapascal.y"
{ yyval = TEST_EQ; ;
    break;}
case 166:
#line 1303 "bapascal.y"
{ yyval = TEST_LT; ;
    break;}
case 167:
#line 1304 "bapascal.y"
{ yyval = TEST_GT; ;
    break;}
case 168:
#line 1305 "bapascal.y"
{ yyval = TEST_LE; ;
    break;}
case 169:
#line 1306 "bapascal.y"
{ yyval = TEST_GE; ;
    break;}
case 170:
#line 1307 "bapascal.y"
{ yyval = TEST_NE; ;
    break;}
case 172:
#line 1312 "bapascal.y"
{
         yyval = yyvsp[0];
         gen_exprval(yyval);
         if ((expr[yyval].typ != ints)&&(expr[yyval].typ != notyp)){
            yyerror("INTEGER type expected");
            expr[yyval].typ = notyp;
         }
      ;
    break;}
case 173:
#line 1321 "bapascal.y"
{
         yyval = yyvsp[0];
         gen_exprval(yyval);
         if ((expr[yyval].typ != ints)&&(expr[yyval].typ != notyp)){
            yyerror("INTEGER type expected");
            expr[yyval].typ = notyp;
         }
         else
            emit(NEGATE);
      ;
    break;}
case 174:
#line 1332 "bapascal.y"
{
         gen_exprval(yyvsp[0]);
         switch (yyvsp[-1]) {
         case DO_OR:
            if ((expr[yyvsp[-2]].typ == bools)&&(expr[yyvsp[0]].typ == bools))
               emit(DO_OR);
            else if ((expr[yyvsp[-2]].typ != notyp)&&(expr[yyvsp[0]].typ != notyp)){
               yyerror("BOOLEAN type expected");
               expr[yyvsp[-2]].typ = notyp;
            }
            break;
         case DO_ADD:
         case DO_SUB:
            expr[yyvsp[-2]].typ = resulttype(expr[yyvsp[-2]].typ,expr[yyvsp[0]].typ);
            if (expr[yyvsp[-2]].typ == ints)
               emit(yyvsp[-1]);
            break;
         } /* switch */
         free_expr(yyvsp[0]);
      ;
    break;}
case 175:
#line 1355 "bapascal.y"
{ gen_exprval(yyvsp[0]); ;
    break;}
case 176:
#line 1358 "bapascal.y"
{ yyval = DO_ADD; ;
    break;}
case 177:
#line 1359 "bapascal.y"
{ yyval = DO_SUB; ;
    break;}
case 178:
#line 1360 "bapascal.y"
{ yyval = DO_OR; ;
    break;}
case 180:
#line 1365 "bapascal.y"
{
         gen_exprval(yyvsp[0]);
         switch(yyvsp[-1]) {
         case DO_AND:
            if ((expr[yyvsp[-2]].typ == bools)&&(expr[yyvsp[0]].typ == bools))
               emit(DO_AND);
            else if ((expr[yyvsp[-2]].typ != notyp)&&(expr[yyvsp[0]].typ != notyp)){
               yyerror("BOOLEAN type expected");
               expr[yyvsp[-2]].typ = notyp;
            }
            break;
         case DO_MUL:
         case DO_DIV:
         case DO_MOD:
            if ((expr[yyvsp[-2]].typ == ints)&&(expr[yyvsp[0]].typ == ints))
               emit(yyvsp[-1]);
            else if ((expr[yyvsp[-2]].typ != notyp)&&(expr[yyvsp[0]].typ != notyp)){
               yyerror("INTEGER type expected");
               expr[yyvsp[-2]].typ = notyp;
            }
            break;
         } /* switch */
         free_expr(yyvsp[0]);
      ;
    break;}
case 181:
#line 1392 "bapascal.y"
{ gen_exprval(yyvsp[0]); ;
    break;}
case 182:
#line 1395 "bapascal.y"
{ yyval = DO_MUL; ;
    break;}
case 183:
#line 1396 "bapascal.y"
{ yyval = DO_DIV; ;
    break;}
case 184:
#line 1397 "bapascal.y"
{ yyval = DO_MOD; ;
    break;}
case 185:
#line 1398 "bapascal.y"
{ yyval = DO_AND; ;
    break;}
case 187:
#line 1403 "bapascal.y"
{
         yyval = new_expr();
         expr[yyval].obj = constant;
         expr[yyval].adr = yyvsp[0];
         expr[yyval].typ = ints;
         expr[yyval].lev = level;
      ;
    break;}
case 188:
#line 1411 "bapascal.y"
{
         yyval = new_expr();
         expr[yyval].obj = constant;
         expr[yyval].adr = laststring[0];
         expr[yyval].typ = chars;
         expr[yyval].lev = level;
      ;
    break;}
case 189:
#line 1418 "bapascal.y"
{ yyval = yyvsp[-1];;
    break;}
case 190:
#line 1420 "bapascal.y"
{
         yyval = yyvsp[0];
         gen_exprval(yyval);
         if (expr[yyval].typ == bools)
            emit(COMPLEMENT);
         else if (expr[yyval].typ != notyp){
            yyerror("BOOLEAN type expected");
            expr[yyval].typ = notyp;
         }
      ;
    break;}
case 191:
#line 1433 "bapascal.y"
{ int k; 
         yyval = new_expr();
         expr[yyval].obj = tab[yyvsp[-2]].obj;
         expr[yyval].typ = tab[yyvsp[-2]].typ;
         expr[yyval].adr = tab[yyvsp[-2]].adr;
         expr[yyval].ref = tab[yyvsp[-2]].ref;
         expr[yyval].lev = tab[yyvsp[-2]].lev;
         expr[yyval].normal = tab[yyvsp[-2]].normal;
         if ((tab[yyvsp[-2]].obj != variable)&&
             (tab[yyvsp[-2]].obj != ext_variable)&&
             (tab[yyvsp[-2]].obj != constant)&& 
             (tab[yyvsp[-2]].obj != function)&&
             (tab[yyvsp[-2]].obj != ext_function))
            yyerror("VARIABLE, CONSTANT, or FUNCTION CALL expected");
         if ((tab[yyvsp[-2]].obj == function)||
             (tab[yyvsp[-2]].obj == ext_function)) {
            expr[yyval].ref = 0;   /* in a func call ref field of func == 0 */
            if (tab[yyvsp[-2]].lev == -1) { /* std function unfinished business */
               stdproc_pcode(yyvsp[-2],parmct);
            } /* if std proc */
            else { /* regular func call */
               /* first check on too few parms */
               k = btab[tab[yyvsp[-2]].ref].lastpar - yyvsp[-2];
               if ((k > parmct)&&(first_parmcterr)) {
                  yyerror("Too few actual parameters in the call");
                  first_parmcterr = 0;
               }
               if (in_cobegin)
                  yyerror("Function calls are not allowed in a COBEGIN block");
               k = btab[tab[yyvsp[-2]].ref].psize - 1;
               if (tab[yyvsp[-2]].mon == 0)
                  emit2(CALL,0,k);
               else
                  emit2(CALL,-1,k); /* CALL pcode: x == -1 => mon call */
               if (tab[yyvsp[-2]].lev < level) /* update display, ord nesting*/
                  emit2(UPDATE_DISPLAY,tab[yyvsp[-2]].lev,level);
               else if ((tab[yyvsp[-2]].mon)&&(level == tab[yyvsp[-2]].lev))
               /* must fix display differently for monitor call */
                  emit2(UPDATE_DISPLAY,level-1,level);
            } /* else regular func */
            toppfs--;
            if (toppfs < 0 )
               parmct = last_pf = 0;
            else {
               parmct = pfstack[toppfs].pct;
               last_pf = pfstack[toppfs].tix;
            }
         }
      ;
    break;}
case 195:
#line 1488 "bapascal.y"
{
         if ((tab[last_pfv].obj == function)||
             (tab[last_pfv].obj == ext_function)) {
            if ((++toppfs) == MAXPFNEST)
               yyerror("Maximum function call nesting exceeded");
            else{  /* legal func call */
               pfstack[toppfs].tix = last_pf = last_pfv;
               pfstack[toppfs].pct = parmct = 0;
               first_stringerr = first_parmcterr = 1;
               if (tab[last_pf].lev != -1){ /* regular proc call */
                  if ((tab[last_pf].mon)&&(tab[prt].mon)&&
                      (tab[last_pf].mon != tab[prt].mon))
                     yyerror("Cross monitor calls not allowed");
                  emit1(MARKSTACK,last_pf-last_predeclared);
               } /* if regular proc */
            } /* legal func call */ 
         } /* if func */
      ;
    break;}
case 200:
#line 1515 "bapascal.y"
{
         if (expr[yyvsp[-1]].typ != strings)
            yyerror("left parameter is not of type 'string'");
         yyval = new_expr();
         expr[yyval].obj = function;
         expr[yyval].typ = ints;
         expr[yyval].normal = 1; /* the value will be left on the stack */
         expr[yyval].ref = 0;
            /* make sure no one uses these */
         expr[yyval].adr = expr[yyval].lev = -1;
         if (expr[yyvsp[0]].typ == rawstrings) 
            emit1(COMPARE_RAWSTRING,expr[yyvsp[0]].adr);
         else 
            emit(COMPARE_STRING);
         free_expr(yyvsp[0]);
      ;
    break;}
case 201:
#line 1534 "bapascal.y"
{
         yyval = new_expr();
         expr[yyval].obj = function;
         expr[yyval].typ = ints;
         expr[yyval].normal = 1; /* the value will be left on the stack */
         expr[yyval].ref = 0;
            /* make sure no one uses these */
         expr[yyval].adr = expr[yyval].lev = -1;
         if (expr[yyvsp[0]].typ == rawstrings)
               /* user wants length of a rawtring !???!!! */
               /* let 'em have it */
            emit1(PUSH_LIT,expr[yyvsp[0]].ref - 1);
         else  /* was a string variable */
            emit(LENGTH_STRING);
         free_expr(yyvsp[0]);
      ;
    break;}
case 202:
#line 1553 "bapascal.y"
{
         if (expr[yyvsp[-1]].typ == strings) {
            if (!expr[yyvsp[-1]].arelt)
               /* addr of array ref is already on the stack */
               emit_push_addr(expr[yyvsp[-1]]);
         } else if (expr[yyvsp[-1]].typ == ints)
            gen_exprval(yyvsp[-1]);
         yyval = yyvsp[-1];
         /* parent rule will free_expr($2) */
      ;
    break;}
case 203:
#line 1564 "bapascal.y"
{
         yyval = new_expr();
         expr[yyval].obj = variable;
         expr[yyval].typ = rawstrings;
         expr[yyval].adr = store_string(laststring,&stab_size);
         expr[yyval].ref = 1 + strlen(laststring); /* includes null char */
         expr[yyval].normal = 1;
         expr[yyval].tix = -1;
      ;
    break;}
case 204:
#line 1576 "bapascal.y"
{
         if (expr[yyvsp[-1]].typ != strings)
            yyerror("Left parameter must be of type 'string'");
         emit(RECEIVE_OP);
         free_expr(yyvsp[-1]);
         yyval = new_expr();
         expr[yyval].obj = function;
         expr[yyval].typ = ints;
         expr[yyval].normal = 1; /* the value will be left on the stack */
         expr[yyval].ref = 0;
            /* make sure no one uses these */
         expr[yyval].adr = expr[yyval].lev = -1;
;
    break;}
case 205:
#line 1590 "bapascal.y"
{
         if (expr[yyvsp[-3]].typ != strings)
            yyerror("Left parameter must be of type 'string'");
         /* implements receive(string,int&) call */
         if (expr[yyvsp[-1]].obj != variable) 
            yyerror("the right 'receive' parameter must be a variable");
         else if (expr[yyvsp[-1]].typ != ints)
            yyerror("the right 'receive' parameter must be of type 'int'");
         else {
            if (!expr[yyvsp[-1]].arelt)
               emit_push_addr(expr[yyvsp[-1]]);
            emit(RECEIVE_ID);
         }
         free_expr(yyvsp[-3]); free_expr(yyvsp[-1]);
         yyval = new_expr();
         expr[yyval].obj = function;
         expr[yyval].typ = ints;
         expr[yyval].normal = 1; /* the value will be left on the stack */
         expr[yyval].ref = 0;
            /* make sure no one uses these */
         expr[yyval].adr = expr[yyval].lev = -1;
      ;
    break;}
case 206:
#line 1615 "bapascal.y"
{
            yyval = new_expr();
            expr[yyval].obj = function;
            expr[yyval].typ = ints;
            expr[yyval].normal = 1; /* the value will be left on the stack */
            expr[yyval].ref = 0;
               /* make sure no one uses these */
            expr[yyval].adr = expr[yyval].lev = -1;
            /* push the parm count for interp's SSCANF_OP to use */
            emit1(PUSH_LIT,sscanf_cnt); 
            emit1(SSCANF_OP,yyvsp[-3]);
         ;
    break;}
case 207:
#line 1630 "bapascal.y"
{ 
            if (expr[yyvsp[-2]].typ != strings)
               yyerror("Leftmost sscanf parameter must be of type 'string'");
            yyval = expr[yyvsp[0]].adr;  /* pass rawstring index up the tree */
            emit_push_addr(expr[yyvsp[-2]]);
            free_expr(yyvsp[-2]); free_expr(yyvsp[0]);
            sscanf_cnt = 0;
         ;
    break;}
case 208:
#line 1641 "bapascal.y"
{  
            if ((expr[yyvsp[0]].typ != ints)&&(expr[yyvsp[0]].typ != strings))
               yyerror(
            "sscanf parameter must be either of type 'int' or type 'string'");
            emit_push_addr(expr[yyvsp[0]]);
            sscanf_cnt++;
            free_expr(yyvsp[0]);
         ;
    break;}
case 209:
#line 1650 "bapascal.y"
{  
            if ((expr[yyvsp[0]].typ != ints)&&(expr[yyvsp[0]].typ != strings))
               yyerror(
            "sscanf parameter must be either of type 'int' or type 'string'");
            emit_push_addr(expr[yyvsp[0]]);
            sscanf_cnt++;
            free_expr(yyvsp[0]);
         ;
    break;}
case 210:
#line 1661 "bapascal.y"
{
         expr[yyvsp[-3]].ref = sizeof(int)*atab[last_aref].elsize;
         expr[yyvsp[-3]].arelt = 1;
         expr[yyvsp[-3]].typ = last_eltyp;
         topars--;
         if (topars >= 0) {
            last_aref = arstack[topars].aref;
            last_eltyp = arstack[topars].eltyp;
         }
      ;
    break;}
case 211:
#line 1674 "bapascal.y"
{
         if (tab[yyvsp[0]].typ != arrays) {
            sprintf(pbuf,"'%s' is not of type ARRAY",tab[yyvsp[0]].name);
            yyerror(pbuf);
            last_aref = 0;
            last_eltyp = notyp;
         }
         else {
            last_aref = tab[yyvsp[0]].ref;
            last_eltyp = atab[last_aref].eltyp;
            /* put addr of array base on the stack */
            emit2((tab[yyvsp[0]].normal ? LOAD_ADDR : LOAD_VALUE),
               tab[yyvsp[0]].lev,tab[yyvsp[0]].adr);
         }
         if (++topars > MAXARNEST) 
            yyerror("Maximum array nesting exceeded");
         else {
            arstack[topars].aref = last_aref;
            arstack[topars].eltyp = last_eltyp;
         }
         yyval = new_expr();
         expr[yyval].obj = tab[yyvsp[0]].obj;
         expr[yyval].typ = last_eltyp;
         expr[yyval].adr = tab[yyvsp[0]].adr;
         expr[yyval].ref = tab[yyvsp[0]].ref;
         expr[yyval].lev = tab[yyvsp[0]].lev;
         expr[yyval].normal = tab[yyvsp[0]].normal;
      ;
    break;}
case 212:
#line 1705 "bapascal.y"
{ 
         gen_exprval(yyvsp[0]);
         last_aref = arstack[topars].aref;
         last_eltyp = arstack[topars].eltyp;
         index_expr(yyvsp[0],&last_aref,&last_eltyp); 
         arstack[topars].aref = last_aref;
         arstack[topars].eltyp = last_eltyp;
         free_expr(yyvsp[0]); 
      ;
    break;}
case 213:
#line 1715 "bapascal.y"
{ 
         gen_exprval(yyvsp[0]);
         last_aref = arstack[topars].aref;
         last_eltyp = arstack[topars].eltyp;
         index_expr(yyvsp[0],&last_aref,&last_eltyp); 
         arstack[topars].aref = last_aref;
         arstack[topars].eltyp = last_eltyp;
         free_expr(yyvsp[0]); 
      ;
    break;}
case 214:
#line 1727 "bapascal.y"
{
         expr[yyvsp[-1]].typ = ints;
         yyval = yyvsp[-1];
      ;
    break;}
case 215:
#line 1734 "bapascal.y"
{ yyval = loc(lastident,level); ;
    break;}
case 216:
#line 1738 "bapascal.y"
{ yyval = enter(lastident,constant,level,level); ;
    break;}
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 1742 "bapascal.y"
   /*start of routines*/

void process_var_inits(int levl)
{
   int i;
   if (curr_var >= 0) {
      for (i = 0; i <= curr_var; i++) {
         if (levl == var_init[i].lev) {
            emit2(LOAD_ADDR,tab[var_init[i].tix].lev,tab[var_init[i].tix].adr);
            emit1(PUSH_LIT,var_init[i].value);
            emit(STORE);
            var_init[i].lev = -1;
         }  /* if */
      }  /* for */  
   }  /* if */
}

void add_var_init(int* curr_var, int tix, int level, int value)
{
   if (++(*curr_var) == MAXVARINIT) {
      sprintf(pbuf,
         "No more than %d variables in a program can be initialized",
         MAXVARINIT);
      yyerror(pbuf); 
   }
   else {
      var_init[*curr_var].value = value;
      var_init[*curr_var].lev = level;
      var_init[*curr_var].tix = tix;   
   }
}   

/*
 *
 *  $Log: bapascal.y,v $
 *  Revision 2.16  2003/05/13 14:01:23  bynum
 *  add boolean initializers, fix proc nesting
 *
 *  Revision 2.15  2002/05/02 13:23:11  bynum
 *  add genutil.h include
 *
 *  Revision 2.14  2001/08/01 13:38:39  bynum
 *  move tab[].adr setting to proc_proto production (for extern procs)
 *
 *  Revision 2.13  2001/07/26 21:19:23  bynum
 *  add ext_function check in the code for the check_func production
 *
 *  Revision 2.12  2001/07/13 19:29:49  bynum
 *  add if-tests to prevent emitting CALL_MONINIT for ext_monitor,
 *  add globtabs.h include
 *
 *  Revision 2.11  2000/08/03 20:57:24  bynum
 *  remove writetab.h include
 *
 *  Revision 2.10  2000/06/02 19:29:14  bynum
 *  add error msg when a function call is attempted in a cobegin block
 *
 *  Revision 2.9  1999/07/06 17:22:08  bynum
 *  add stmts to RECEIVE_OP and RECEIVE_ID productions to set
 *  type of receive func to int
 *
 *  Revision 2.8  1998/11/23 22:55:19  bynum
 *  fix code emission order for the FOR loop parms
 *
 *  Revision 2.7  1998/10/28 21:38:31  bynum
 *  fix initialization, add semaphore, binary semaphore initialization
 *
 *  Revision 2.6  1998/07/23 17:14:56  bynum
 *  remove storing last_tab into btab[main}.last at the END. stmt.  It
 *  caused the btab[main].last parm to be invalid.
 *
 *  Revision 2.5  1997/12/16 19:41:43  bynum
 *  fix $-references in several rules
 *
 *  Revision 2.4  1997/12/16 02:53:26  bynum
 *  change tab[$2].mon ref to tab[$1].mon when emitting ENTERMON on proc entry
 *
 * Revision 2.3  1997/10/21  06:37:10  bynum
 * add sscanf, sprintf rules, move dist_stmt rule into special_proc_call rule
 *
 * Revision 2.2  1997/10/18  19:19:15  bynum
 * add EXTERN support, add last_atab production to find last array dim in atab
 *
 * Revision 2.1  1997/07/10  17:06:55  bynum
 * fix procedure, function, program entry point problems, fix parmct error
 *
 * Revision 2.0  1997/07/09  11:51:50  bynum
 * make PROGRAM optional, add EXTERNALs, add initializers
 *
 * Revision 1.15  1997/06/20  10:05:12  bynum
 * add send, receive, broadcast, int() typecast
 *
 * Revision 1.14  1997/06/17  05:43:15  bynum
 * add string suppor
 *
 * Revision 1.13  1997/04/02  09:22:09  bynum
 * change yyerror() to use 'lasttoken' instead of 'yytext'
 *
 * Revision 1.12  1997/03/25  14:52:43  bynum
 * incorporate changes in the include directory, add prototypes to silence
 * gcc -Wall
 *
 * Revision 1.11  1996/03/06  13:47:19  bynum
 * add extern to yyin,yyout decls
 *
 * Revision 1.10  1995/09/19  14:54:51  bynum
 * move declaration of 'comp_date' array to date.c
 *
 * Revision 1.9  1995/09/07  14:36:15  bynum
 * move in some variables declared in bacglobs.h, change includes
 * to the new structure of the ../include directory, remove 'fatal'
 * and 'warning' code
 *
 * Revision 1.8  1995/08/29  16:49:03  bynum
 * get rid of shift/reduce conflict on if-then-else
 *
 * Revision 1.7  1995/07/12  10:45:47  bynum
 * add productions to handle '#include <..>' and '#include ".."'
 * constructs, add code to block recursive file includes
 *
 * Revision 1.6  1995/07/09  19:25:00  bynum
 * add 'arstack' for stacking 'atab' references in parsing array
 * variables
 *
 * Revision 1.5  1995/07/06  14:17:20  bynum
 * change 'last_pf' to parsing stack ref $1 where possible to prevent
 * ambiguity, guard 'parmct' and 'last_pf' assignments when toppfs < 0,
 * replace PCODE emission for std procs with 'stdproc_pcode' calls
 *
 * Revision 1.4  1995/07/04  08:58:17  bynum
 * add pfstack to handle nested proc/function calls, fix parsing level of
 * fcn name, set 'ref' field of function tab entry to 0 in a fcn call,
 * break yyerror output to two separate lines
 *
 * Revision 1.3  1995/06/30  14:01:00  bynum
 * add 'atomic' keyword and supporting data items
 *
 * Revision 1.2  1995/06/22  06:39:57  bynum
 * add include_dcl_part production, code to handle include files, modify
 * yyerror to accommodate include files
 *
 *
 */
