#ifndef AR_REPLACE
#define AR_REPLACE
/*
 *  include file for public arreplac.c functions
 *  BACI archiver
 *     Bill Bynum
 *     May 2000
 */

void replace_members(Archive* ar,char** files,int num_files,int verbose,
   int insert_symdef);
/*  
 *  replace members named in the list of files 'files' (there
 *  are 'num_files' filenames in the list) from the archive file
 *  described by '*ar'
 *
 *  if (verbose) perform the action verbosely
 *
 *  if (insert_symdef) and there is no SYMDEF member, then create one
 *
 *  if (num_files > 0) and there is no SYMDEF member and !insert_symdef
 *  then abort
 */

/*
 *  $Log: arreplac.h,v $
 *  Revision 1.4  2000/05/30 15:48:27  bynum
 *  change comment at top from ar68xx to BACI
 *
 * Revision 1.3  1996/04/23  17:05:14  bynum
 * add address comment, move code from 'ar68xx.c' to 'replace_members'
 *
 * Revision 1.2  1996/01/24  17:05:08  bynum
 * change to use of Archive struct
 *
 * Revision 1.1  1996/01/20  08:51:47  bynum
 * Initial revision
 *
 *
 */
#endif
