#ifndef AR_WRITE
#define AR_WRITE
/*
 *  include file for public arwrite.c functions
 *  BACI archiver
 *     Bill Bynum
 *     May 2000
 */

#include "artables.h"

void write_archive(Archive* ar);
/*
 *  write the new archive file to disk
 *
 *  if ar->rf== NO_ARCHIVE, no old archive exists;
 *  otherwise, ar->rf is the file descriptor of the (open) old archive file
 *  (having name 'ar->fname')
 */

/*
 *  $Log: arwrite.h,v $
 *  Revision 1.6  2001/06/06 20:30:43  bynum
 *  DOS-ize filenames in include stmts
 *
 *  Revision 1.5  2000/05/30 15:59:17  bynum
 *  switch top comment from ar68xx to BACI ar
 *
 * Revision 1.4  1996/04/23  17:09:00  bynum
 * add address comment, switch to using FILE* for the read file descriptor
 *
 * Revision 1.3  1996/01/24  17:07:46  bynum
 * change to use of Archive struct
 *
 * Revision 1.2  1996/01/20  09:05:50  bynum
 * add #ifndef/#endif to prevent mutliple includes, remove references to
 * non-public procs
 *
 * Revision 1.1  1996/01/15  13:37:45  bynum
 * Initial revision
 *
 */
#endif
